#!/bin/sh
FILE="/var/log/hotswap_dump"
nr_stat_loops=3

echo -e "\n*** Hotswap system dump ***********************************\n" > $FILE

date >> $FILE 

echo -e "\n*** free  **************************************************\n" >> $FILE
free >> $FILE

echo -e "\n*** df ****************************************************\n" >> $FILE
df >> $FILE

echo -e "\n*** cat /proc/slabinfo ************************************\n" >> $FILE
cat /proc/slabinfo >> $FILE

echo -e "\n*** top -n 1 **********************************************\n" >> $FILE
top -n 1 >> $FILE

echo -e "\n*** mpstat -P ALL *****************************************\n" >> $FILE
mpstat -P ALL >> $FILE

echo -e "\n*** ps -eLo pid,tid,pcpu,priority,cmd *********************\n" >> $FILE
ps -eLo pid,tid,pcpu,priority,cmd >> $FILE

echo -e "\n*** cat /proc/net/itbridge/br0/bridge *********************\n" >> $FILE
cat /proc/net/itbridge/br0/bridge >> $FILE

echo -e "\n*** bridge_tool br0 mt show ucast *************************\n" >> $FILE
bridge_tool br0 mt show ucast >> $FILE

echo -e "\n*** cat /proc/net/itbridge/config *************************\n" >> $FILE
cat /proc/net/itbridge/config >> $FILE

for i in $( seq 1 $nr_stat_loops )
  do
     echo -e "\n*** bridge_tool br0 stat all *******************************\n" >> $FILE
     date >> $FILE
     bridge_tool br0 stat all >> $FILE
     

     #dump statistics with delay between dumps 
     if [ $i != $nr_stat_loops ]; then
         echo -e "\n*** sleep 1 ***********************************************\n" >> $FILE
         sleep 1
     fi
  done

echo -e "\n*** bridge_tool br0 flow show summary *********************\n" >> $FILE
bridge_tool br0 flow show summary >> $FILE

echo -e "\n*** bridge_tool br0 flow show list ************************\n" >> $FILE
bridge_tool br0 flow show list >> $FILE

date >> $FILE
echo -e "\n*** end of dump *******************************************\n" >> $FILE
