#!/bin/bash

#Usage: OLT_verify_lic.sh <license_file_name>
#Example: OLT_verify_lic.sh OLT_licence-Z04E00057G-8-4.lic

if [ "$#" -ne 1 ]; then
    echo "#Usage: OLT_verify_lic.sh <license_file_name>"
    echo "#Example: OLT_verify_lic.sh OLT_licence-Z04E00057G-8-4.lic"
    exit 0
fi

license_file=$1

MYDIR="$(dirname "$(readlink -f "$0")")"
PUBLIC_KEY="$MYDIR/OLT_public.key"
#echo "PUBLIC_KEY=$PUBLIC_KEY"

#remove all lines begin with # and copy to sign file
sed '/^#/ d' < $license_file >sha1.sign.txt 

#copy text to verify to temporary file
grep "^#" $license_file > license.txt

#decode from base64 to bin
openssl base64 -d -in sha1.sign.txt > sha1.sign

#verify licence file
openssl dgst -sha1 -verify $PUBLIC_KEY -signature sha1.sign license.txt
rm sha1.sign sha1.sign.txt license.txt

