#!/bin/sh
#Usage:
#The script is checking if the listed pids are running. If pid is not found script will reboot the borad thorugh sysup. 
#To add your own process to check just add its name into array pidlist under correct board. 
#For debugging purposes you can enable checking with kill -USR1 pidOfScript
# or disable it with kill -USR2 pidOfScript.   

LOGGER_INFO="logger -p user.alert -t bllSupervisor --"

trap "check=1" SIGUSR1
trap "check=0" SIGUSR2
FILE_MAPLE_CRASH_PRINT="/opt/si2000/neroot/active/bridge_SW/bin/bllMapleCrashPrint.sh"
ddrDumpFile="/opt/si2000/mnroot/storage/maple_ddr_dump"

check=0
cord=false

if [ -f "/opt/si2000/neroot/active/openolt_agent/bin/openolt" ]; then
   cord=true
fi

    case "$1" in
        SPA)
            pidlist=(
                itbridge/1
                itbridge_timer/
                olt.out
                bcm_maple_daemon
                itStp
                dhcpra.bin
                pppoeia.bin
                #bcmtr_rx0
            )
           ;;
        SPB)
             pidlist=(
                itbridge/1
                itbridge_timer/
                bcm_maple_daemon
                olt.out
                itStp
                dhcpra.bin
                pppoeia.bin
                #bcmtr_rx0
            )          
           ;;
        SPC)
             if $cord ; then
                pidlist=(
                   itbridge/1
                   itbridge_timer/
                   openolt
                   "Delay;3;bcm_maple_daemon"
                   #"Delay;5;bcmtr_rx0"
               )          
             else
                pidlist=(
                   itbridge/1
                   itbridge_timer/
                   bcm_maple_daemon
                   olt.out
                   itStp
                   dhcpra.bin
                   pppoeia.bin
                   #bcmtr_rx0
               )          
            fi
           ;;
        SPD)
             if $cord ; then
                pidlist=(
                   itbridge/1
                   itbridge_timer/
                   openolt
                   "Delay;3;bcm_maple_daemon"   #delay 30-40 s after start ob bllSupervisor process control loop - demo to show usage of feature
                   #"Delay;5;bcmtr_rx0"
               )          
             else
                pidlist=(
                   itbridge/1
                   itbridge_timer/
                   bcm_maple_daemon
                   olt.out
                   itStp
                   dhcpra.bin
                   pppoeia.bin
                   #bcmtr_rx0
               )          
            fi
           ;;
        SPF)
             if $cord ; then
                pidlist=(
                   itbridge/1
                   itbridge_timer/
                   openolt
                   "Delay;3;bcm_maple_daemon"
               )          
             else
                pidlist=(
                   itbridge/1
                   itbridge_timer/
                   bcm_maple_daemon
                   olt.out
                   itStp
                   dhcpra.bin
                   pppoeia.bin
               )          
            fi
           ;;
        SPG)
             if $cord ; then
                pidlist=(
                   itbridge/1
                   itbridge_timer/
                   openolt
                   "Delay;3;bcm_maple_daemon"
               )          
             else
                pidlist=(
                   itbridge/1
                   itbridge_timer/
                   bcm_maple_daemon
                   olt.out
                   itStp
                   dhcpra.bin
                   pppoeia.bin
               )          
            fi
           ;;
        SPH)
             if $cord ; then
                pidlist=(
                   itbridge/1
                   itbridge_timer/
                   openolt
                   "Delay;3;bcm_maple_daemon"
                   #"Delay;5;bcmtr_rx0"
               )          
             else
                pidlist=(
                   itbridge/1
                   itbridge_timer/
                   bcm_maple_daemon
                   olt.out
                   itStp
                   dhcpra.bin
                   pppoeia.bin
                   #bcmtr_rx0
               )          
            fi
           ;;
          SPI)
             if $cord ; then
                pidlist=(
                   itbridge/1
                   itbridge_timer/
                   openolt
                   "Delay;3;bcm_maple_daemon"
               )          
             else
                pidlist=(
                   itbridge/1
                   itbridge_timer/
                   bcm_maple_daemon
                   olt.out
                   #itStp
                   dhcpra.bin
                   pppoeia.bin
               )          
            fi
           ;;
        SPJ | SPK)
            pidlist=(
              itbridge/1
              itbridge_timer/
              bcm_maple_daemon
              dev_mgmt_daemon
              olt.out
              itStp
              dhcpra.bin
              pppoeia.bin
              bin/la
              pcie_proxy_rx1-
              pcie_proxy_rx0-
              )
            ;;
        SGT)
           pidlist=(
              itStp
              dhcpra.bin
              pppoeia.bin
          )
         ;;
        SGV)
           pidlist=(
              itStp
              dhcpra.bin
              pppoeia.bin
          ) 
           ;;
        DGA)
           pidlist=(
           
          )
         ;;
        SFE)
           pidlist=(
              itStp
              dhcpra.bin
              pppoeia.bin
          )
         ;;
        SFD)
           pidlist=(
              itStp
              dhcpra.bin
              pppoeia.bin
          )
         ;;
        SFH)
           pidlist=(
              itStp
              dhcpra.bin
              pppoeia.bin
          )
          ;;
         *)
              echo "bllSupervisor: Please define boadr type ($1)" | ${LOGGER_INFO}
              exit
              ;;
    esac

        

count=0
while [ "x${pidlist[count]}" != "x" ]
do
   count=$(( $count + 1 ))
done

if [ $count == 0 ];
  then
    echo "No pid defined!!" | ${LOGGER_INFO}
    exit
fi



check_process(){
        # check the args
        if [ "$1" == "" ];
        then
                return 0
        fi
       
        if [ `ps -ef | grep "$1" | grep -v "grep" | wc -l` -ge 1 ];
        then
                return 1
        else
                return 0
        fi
}
     
    # check wheter the instance of thread exsits
    while [ 1 ] ; do

      if [ $check == 1 ];
      then
        i=0
     while [ $i -ne $count ] ; do
            if [[ "${pidlist[$i]}" == "Delay;"* ]];
            then
              IN=${pidlist[$i]}
              arg1=(${IN//;/ })
              arg2_tmp=(${IN//Delay;/})
              arg2=(${arg2_tmp//;/ })
              arg3=(${IN//*;*;/})
              m=$(($arg2-1));
              if [[ m -ne 0 ]]; then
                pidlist[$i]="$arg1;$m;$arg3"
              else
                pidlist[$i]=$arg3
              fi
              CHECK_RET=1
            else
              check_process ${pidlist[i]} # the thread name
              CHECK_RET=$?
             fi

            if [ $CHECK_RET == 0 ]; # none exist
            then
              #if [ "${pidlist[$i]}" == "bcmtr_rx0" ];
              #then
              #  # sleep 25s and then reboot the board.
              #  sleep 25
              #  sh $FILE_MAPLE_CRASH_PRINT
              #fi
              echo "Process ${pidlist[i]} is mising!!!!!!!!!! Let sysup reboot the board." | ${LOGGER_INFO}
              /opt/iskratel/bin/sysupReboot ${pidlist[i]} 1 &
              exit
            fi
          i=$(( $i + 1 ))
        done
      fi
      sleep 10
    done
