#!/bin/sh

if [ -f "/opt/si2000/neroot/active/openolt_agent/bin/openolt" ]; then
	echo "it-snmpd hasn't been  started for CORD project!"
	exit
fi

SNMPDOPTS='-Lf /dev/null -p /var/run/it-snmpd.pid -I -vmstat,hr_device,hr_network,hr_print,hr_disk,hr_partition,hr_filesys,hr_swinst'
#needed for ECFM_WANTED
[ -e /etc/sysconfig/ecfm-info ] && . /etc/sysconfig/ecfm-info
#old path
DAEMON=/opt/si2000/neroot/active/bin/it-snmpd
#if old file not exist, try new path
[ ! -e $DAEMON ] && DAEMON=/opt/si2000/neroot/active/it-snmpd/bin/it-snmpd

case "$1" in
	"start" )
		rm /var/run/it-snmpd-flag &>/dev/null
		sleep 2
		snmpdsh=$(ps ax| grep "it-snmpd.sh wai" | grep -v grep | wc -l 2>&1)
		if [ $snmpdsh -eq 0 ]; then
			/bin/sh $0 wait &
		fi
	;;
	"stop" )
		echo yes > /var/run/it-snmpd-flag
		start-stop-daemon --quiet --stop --exec $DAEMON
		;;
	"wait" )
		SHOULD_STOP=
		while [ "$SHOULD_STOP" != "yes" ]
		do
			SHOULD_STOP=`cat /var/run/it-snmpd-flag 2>/dev/null`
			if [ "$SHOULD_STOP" != "yes" ]; then
				if ! pidof it-snmpd >/dev/null; then
					if [ -e /var/run/it-snmpd.pid ]; then
						rm /var/run/it-snmpd.pid
					fi
					if [ -e /var/run/snmpd.pid ]; then
						start-stop-daemon --quiet --stop --exec /usr/sbin/snmpd
					fi
					start-stop-daemon --quiet --start --exec $DAEMON -- $SNMPDOPTS
				else
					snmpget -v2c -t60 -r2 -c_local_ISA_ 127.0.0.1 1.3.6.1.2.1.1.3.0 1>/dev/null 2>&1
					if [ $? -ne 0 ]; then
						echo "`date` Process it-snmpd is not responding and it'll be restarted now." >>/var/log/net-snmp.log
						start-stop-daemon --quiet --stop --exec $DAEMON
						sleep 2
						start-stop-daemon --quiet --stop --signal 9 --exec $DAEMON
					fi
				fi
				sleep 60 
			fi
		done
		;;
	"restart" )
		start-stop-daemon --quiet --stop --exec $DAEMON
		;;
	*) ;;
esac
