#!/bin/bash

XML=$2
if [ -z "$XML" ]; then
  XML=reset_reason_config.xml
fi
DEBUG=0
RESET_REASON="No information available on reset!"
CORE1=""
CORE2=""
CORE3=""
CORE4=""
PROCESCORE1=""
PROCESCORE2=""
PROCESCORE3=""
PROCESCORE4=""

printResult()
{
  echo "================================================="
  [ "$BOARD_TYPE" != "" ] &&      echo "Board: $BOARD_TYPE"
  echo "Report generated on: `date`"  
  echo "Reset date  : $RESET_DATE" 
  echo "Package version: $STEER_VER"
  echo "Reset reason:"
  echo ""
  
  if [[ "$RESET_REASON" != "No information available on reset!" ]]; then
    echo "$resetString"
    echo ""
  fi

  echo "$RESET_REASON"
  if [ ! -z "$CORE_DUMP" ]; then
    echo ""
    echo "Coredump:"
    echo ""
    echo "$CORE_DUMP"
  fi
  
  echo ""
  
  if [[ $checkDtrc == 1 ]]; then
    if [ ! -z "$CORE1" ]; then
      echo "Core " "$CORE1" ":"
      if [ ! -z "$PROCESCORE1" ]; then
        echo "Last process:"
        echo "$PROCESCORE1"
      fi         
    fi
    
    echo ""
    
    if [ ! -z "$CORE2" ]; then
      echo "Core " "$CORE2" ":"
      if [ ! -z "$PROCESCORE2" ]; then
        echo "Last process:"
        echo "$PROCESCORE2"
      fi         
    fi    

    echo ""
    
    if [ ! -z "$CORE3" ]; then
      echo "Core " "$CORE3" ":"
      if [ ! -z "$PROCESCORE3" ]; then
        echo "Last process:"
        echo "$PROCESCORE3"
      fi         
    fi   

    echo ""
    
    if [ ! -z "$CORE4" ]; then
      echo "Core " "$CORE4" ":"
      if [ ! -z "$PROCESCORE4" ]; then
        echo "Last process:"
        echo "$PROCESCORE4"
      fi         
    fi   
  fi  
  
  echo "================================================="
}

# $1 = packageString1, packageString2, packageString3
getResetPacketFile1()
{
  if [ ! -z $searchFile1 ]; then
    isTextInFile1 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      STEER=`awk -F "$1" '/'"$1"'/{print $2}' $searchFolder/$searchFile1 | tail -n 1`
    fi
  fi
  
  echo "$STEER"
}

# $1 = packageString1, packageString2, packageString3
getResetPacketFile2()
{
  if [ ! -z $searchFile2 ]; then
    isTextInFile2 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      STEER=`awk -F "$1" '/'"$1"'/{print $2}' $searchFolder/$searchFile2 | tail -n 1`
    fi
  fi
  
  echo "$STEER"
}

# $1 = packageString1, packageString2, packageString3
getResetPacketFile3()
{
  if [ ! -z $searchFile3 ]; then
    isTextInFile3 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      STEER=`awk -F "$1" '/'"$1"'/{print $2}' $searchFolder/$searchFile3 | tail -n 1`
    fi
  fi
  
  echo "$STEER"
}

# $1 = packageString1, packageString2, packageString3
getResetPacketFile4()
{
  if [ ! -z $searchFile4 ]; then
    isTextInFile4 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      STEER=`awk -F "$1" '/'"$1"'/{print $2}' $searchFolder/$searchFile4 | tail -n 1`
    fi
  fi
  
  echo "$STEER"
}

# $1 = packageString1, packageString2, packageString3
getResetPacketFile5()
{
  if [ ! -z $searchFile5 ]; then
    isTextInFile5 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      STEER=`awk -F "$1" '/'"$1"'/{print $2}' $searchFolder/$searchFile5 | tail -n 1`
    fi
  fi
  
  echo "$STEER"
}

# $1 = packageString1, packageString2, packageString3
getResetPacketFile6()
{
  if [ ! -z $searchFile6 ]; then
    isTextInFile6 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      STEER=`awk -F "$1" '/'"$1"'/{print $2}' $searchFolder/$searchFile6 | tail -n 1`
    fi
  fi
  
  echo "$STEER"
}

getResetPackage()
{
  local res=$(getResetPacketFile1 "$packageString1")

  if [ ! -z "$res" ]; then
    STEER_VER="$res"
  fi
  
  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile2 "$packageString1")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi
  
  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile3 "$packageString1")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi 

  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile4 "$packageString1")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi 
  
  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile5 "$packageString1")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi   
  
  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile6 "$packageString1")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi 
  
  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile1 "$packageString2")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi  
  
  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile2 "$packageString2")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi  

  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile3 "$packageString2")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi  
  
  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile4 "$packageString2")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi 
  
  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile5 "$packageString2")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi   
  
  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile6 "$packageString2")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi 
  
  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile1 "$packageString3")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi  
  
  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile2 "$packageString3")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi  

  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile3 "$packageString3")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi  

  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile4 "$packageString3")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi    
  
  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile5 "$packageString3")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi      
  
  if [[ "$STEER_VER" == "unknown" ]]; then
    local res=$(getResetPacketFile6 "$packageString3")

    if [ ! -z "$res" ]; then
      STEER_VER="$res"
    fi
  fi      
}

# $1 = boardString1, boardString2, boardString3
getResetBoardFile1()
{
  if [ ! -z $searchFile1 ]; then
    isTextInFile1 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then 
      #BOARD=`grep -i "$1" $searchFolder/$searchFile1 2>/dev/null | grep -oP '\w+(?= '"$1"')' | tail -n 1`  
      BOARD=`grep -i "$1" $searchFolder/$searchFile1 2>/dev/null | grep -i "$board1" | tail -n 1`  
      if [ -z "$BOARD" ]; then
        BOARD=`grep -i "$1" $searchFolder/$searchFile1 2>/dev/null | grep -i "$board2" | tail -n 1`  
        if [ -z "$BOARD" ]; then
          BOARD=`grep -i "$1" $searchFolder/$searchFile1 2>/dev/null | grep -i "$board3" | tail -n 1`  
          if [ -z "$BOARD" ]; then
            BOARD=`grep -i "$1" $searchFolder/$searchFile1 2>/dev/null | grep -i "$board4" | tail -n 1`  
            if [ -z "$BOARD" ]; then
              BOARD=`grep -i "$1" $searchFolder/$searchFile1 2>/dev/null | grep -i "$board5" | tail -n 1`  
              if [ -z "$BOARD" ]; then
                BOARD=`grep -i "$1" $searchFolder/$searchFile1 2>/dev/null | grep -i "$board6" | tail -n 1`  
                if [ -z "$BOARD" ]; then
                  BOARD=`grep -i "$1" $searchFolder/$searchFile1 2>/dev/null | grep -i "$board7" | tail -n 1`  
                  if [ -z "$BOARD" ]; then
                    BOARD=`grep -i "$1" $searchFolder/$searchFile1 2>/dev/null | grep -i "$board8" | tail -n 1`  
                    if [ -z "$BOARD" ]; then
                      BOARD=`grep -i "$1" $searchFolder/$searchFile1 2>/dev/null | grep -i "$board9" | tail -n 1`  
                      if [ -z "$BOARD" ]; then
                        BOARD=`grep -i "$1" $searchFolder/$searchFile1 2>/dev/null | grep -i "$board10" | tail -n 1`  
                        if [ -z "$BOARD" ]; then
                          BOARD=`grep -i "$1" $searchFolder/$searchFile1 2>/dev/null | grep -i "$board11" | tail -n 1`
                          if [ -z "$BOARD" ]; then
                            BOARD=`grep -i "$1" $searchFolder/$searchFile1 2>/dev/null | grep -i "$board12" | tail -n 1`  
                            if [ ! -z "$BOARD" ]; then
                              BOARD=$board12
                            fi
                          else 
                            BOARD=$board11
                          fi 
                        else
                          BOARD=$board10
                        fi   
                      else
                        BOARD=$board9
                      fi  
                    else
                      BOARD=$board8
                    fi   
                  else
                    BOARD=$board7
                  fi 
                else
                  BOARD=$board6
                fi 
              else
                BOARD=$board5
              fi 
            else
              BOARD=$board4
            fi  
          else
            BOARD=$board3            
          fi   
        else
          BOARD=$board2
        fi
      else
        BOARD=$board1
      fi
    fi
  fi
  
  echo "$BOARD"
}

# $1 = boardString1, boardString2, boardString3
getResetBoardFile2()
{
  if [ ! -z $searchFile2 ]; then
    isTextInFile2 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then 
      #BOARD=`grep -i "$1" $searchFolder/$searchFile2 2>/dev/null | grep -oP '\w+(?= '"$1"')' | tail -n 1`   
      BOARD=`grep -i "$1" $searchFolder/$searchFile2 2>/dev/null | grep -i "$board1" | tail -n 1`  
      if [ -z "$BOARD" ]; then
        BOARD=`grep -i "$1" $searchFolder/$searchFile2 2>/dev/null | grep -i "$board2" | tail -n 1`  
        if [ -z "$BOARD" ]; then
          BOARD=`grep -i "$1" $searchFolder/$searchFile2 2>/dev/null | grep -i "$board3" | tail -n 1`  
          if [ -z "$BOARD" ]; then
            BOARD=`grep -i "$1" $searchFolder/$searchFile2 2>/dev/null | grep -i "$board4" | tail -n 1`  
            if [ -z "$BOARD" ]; then
              BOARD=`grep -i "$1" $searchFolder/$searchFile2 2>/dev/null | grep -i "$board5" | tail -n 1`  
              if [ -z "$BOARD" ]; then
                BOARD=`grep -i "$1" $searchFolder/$searchFile2 2>/dev/null | grep -i "$board6" | tail -n 1`  
                if [ -z "$BOARD" ]; then
                  BOARD=`grep -i "$1" $searchFolder/$searchFile2 2>/dev/null | grep -i "$board7" | tail -n 1`  
                  if [ -z "$BOARD" ]; then
                    BOARD=`grep -i "$1" $searchFolder/$searchFile2 2>/dev/null | grep -i "$board8" | tail -n 1`  
                    if [ -z "$BOARD" ]; then
                      BOARD=`grep -i "$1" $searchFolder/$searchFile2 2>/dev/null | grep -i "$board9" | tail -n 1`  
                      if [ -z "$BOARD" ]; then
                        BOARD=`grep -i "$1" $searchFolder/$searchFile2 2>/dev/null | grep -i "$board10" | tail -n 1`  
                        if [ -z "$BOARD" ]; then
                          BOARD=`grep -i "$1" $searchFolder/$searchFile2 2>/dev/null | grep -i "$board11" | tail -n 1`
                          if [ -z "$BOARD" ]; then
                            BOARD=`grep -i "$1" $searchFolder/$searchFile2 2>/dev/null | grep -i "$board12" | tail -n 1`  
                            if [ ! -z "$BOARD" ]; then
                              BOARD=$board12
                            fi
                          else 
                            BOARD=$board11
                          fi 
                        else
                          BOARD=$board10
                        fi   
                      else
                        BOARD=$board9
                      fi  
                    else
                      BOARD=$board8
                    fi   
                  else
                    BOARD=$board7
                  fi 
                else
                  BOARD=$board6
                fi 
              else
                BOARD=$board5
              fi 
            else
              BOARD=$board4
            fi  
          else
            BOARD=$board3            
          fi   
        else
          BOARD=$board2
        fi
      else
        BOARD=$board1
      fi
    fi    
  fi
  
  echo "$BOARD"
}

# $1 = boardString1, boardString2, boardString3
getResetBoardFile3()
{
  if [ ! -z $searchFile3 ]; then
    isTextInFile3 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then 
      #BOARD=`grep -i "$1" $searchFolder/$searchFile3 | grep -oP '\w+(?= '"$1"')' | tail -n 1`   
      BOARD=`grep -i "$1" $searchFolder/$searchFile3 | grep -i "$board1" | tail -n 1`  
      if [ -z "$BOARD" ]; then
        BOARD=`grep -i "$1" $searchFolder/$searchFile3 | grep -i "$board2" | tail -n 1`  
        if [ -z "$BOARD" ]; then
          BOARD=`grep -i "$1" $searchFolder/$searchFile3 | grep -i "$board3" | tail -n 1`  
          if [ -z "$BOARD" ]; then
            BOARD=`grep -i "$1" $searchFolder/$searchFile3 | grep -i "$board4" | tail -n 1`  
            if [ -z "$BOARD" ]; then
              BOARD=`grep -i "$1" $searchFolder/$searchFile3 | grep -i "$board5" | tail -n 1`  
              if [ -z "$BOARD" ]; then
                BOARD=`grep -i "$1" $searchFolder/$searchFile3 | grep -i "$board6" | tail -n 1`  
                if [ -z "$BOARD" ]; then
                  BOARD=`grep -i "$1" $searchFolder/$searchFile3 | grep -i "$board7" | tail -n 1`  
                  if [ -z "$BOARD" ]; then
                    BOARD=`grep -i "$1" $searchFolder/$searchFile3 | grep -i "$board8" | tail -n 1`  
                    if [ -z "$BOARD" ]; then
                      BOARD=`grep -i "$1" $searchFolder/$searchFile3 | grep -i "$board9" | tail -n 1`  
                      if [ -z "$BOARD" ]; then
                        BOARD=`grep -i "$1" $searchFolder/$searchFile3 | grep -i "$board10" | tail -n 1`  
                        if [ -z "$BOARD" ]; then
                          BOARD=`grep -i "$1" $searchFolder/$searchFile3 | grep -i "$board11" | tail -n 1`
                          if [ -z "$BOARD" ]; then
                            BOARD=`grep -i "$1" $searchFolder/$searchFile3 | grep -i "$board12" | tail -n 1`  
                            if [ ! -z "$BOARD" ]; then
                              BOARD=$board12
                            fi
                          else 
                            BOARD=$board11
                          fi 
                        else
                          BOARD=$board10
                        fi   
                      else
                        BOARD=$board9
                      fi  
                    else
                      BOARD=$board8
                    fi   
                  else
                    BOARD=$board7
                  fi 
                else
                  BOARD=$board6
                fi 
              else
                BOARD=$board5
              fi 
            else
              BOARD=$board4
            fi  
          else
            BOARD=$board3            
          fi   
        else
          BOARD=$board2
        fi
      else
        BOARD=$board1
      fi
    fi     
  fi
  
  echo "$BOARD"
}

# $1 = boardString1, boardString2, boardString3
getResetBoardFile4()
{
  if [ ! -z $searchFile4 ]; then
    isTextInFile4 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then 
      #BOARD=`grep -i "$1" $searchFolder/$searchFile4 | grep -oP '\w+(?= '"$1"')' | tail -n 1`   
      BOARD=`grep -i "$1" $searchFolder/$searchFile4 | grep -i "$board1" | tail -n 1`  
      if [ -z "$BOARD" ]; then
        BOARD=`grep -i "$1" $searchFolder/$searchFile4 | grep -i "$board2" | tail -n 1`  
        if [ -z "$BOARD" ]; then
          BOARD=`grep -i "$1" $searchFolder/$searchFile4 | grep -i "$board3" | tail -n 1`  
          if [ -z "$BOARD" ]; then
            BOARD=`grep -i "$1" $searchFolder/$searchFile4 | grep -i "$board4" | tail -n 1`  
            if [ -z "$BOARD" ]; then
              BOARD=`grep -i "$1" $searchFolder/$searchFile4 | grep -i "$board5" | tail -n 1`  
              if [ -z "$BOARD" ]; then
                BOARD=`grep -i "$1" $searchFolder/$searchFile4 | grep -i "$board6" | tail -n 1`  
                if [ -z "$BOARD" ]; then
                  BOARD=`grep -i "$1" $searchFolder/$searchFile4 | grep -i "$board7" | tail -n 1`  
                  if [ -z "$BOARD" ]; then
                    BOARD=`grep -i "$1" $searchFolder/$searchFile4 | grep -i "$board8" | tail -n 1`  
                    if [ -z "$BOARD" ]; then
                      BOARD=`grep -i "$1" $searchFolder/$searchFile4 | grep -i "$board9" | tail -n 1`  
                      if [ -z "$BOARD" ]; then
                        BOARD=`grep -i "$1" $searchFolder/$searchFile4 | grep -i "$board10" | tail -n 1`  
                        if [ -z "$BOARD" ]; then
                          BOARD=`grep -i "$1" $searchFolder/$searchFile4 | grep -i "$board11" | tail -n 1`
                          if [ -z "$BOARD" ]; then
                            BOARD=`grep -i "$1" $searchFolder/$searchFile4 | grep -i "$board12" | tail -n 1`  
                            if [ ! -z "$BOARD" ]; then
                              BOARD=$board12
                            fi
                          else 
                            BOARD=$board11
                          fi 
                        else
                          BOARD=$board10
                        fi   
                      else
                        BOARD=$board9
                      fi  
                    else
                      BOARD=$board8
                    fi   
                  else
                    BOARD=$board7
                  fi 
                else
                  BOARD=$board6
                fi 
              else
                BOARD=$board5
              fi 
            else
              BOARD=$board4
            fi  
          else
            BOARD=$board3            
          fi   
        else
          BOARD=$board2
        fi
      else
        BOARD=$board1
      fi
    fi       
  fi
  
  echo "$BOARD"
}

# $1 = boardString1, boardString2, boardString3
getResetBoardFile5()
{
  if [ ! -z $searchFile5 ]; then
    isTextInFile5 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then 
      #BOARD=`grep -i "$1" $searchFolder/$searchFile5 | grep -oP '\w+(?= '"$1"')' | tail -n 1`   
      BOARD=`grep -i "$1" $searchFolder/$searchFile5 | grep -i "$board1" | tail -n 1`  
      if [ -z "$BOARD" ]; then
        BOARD=`grep -i "$1" $searchFolder/$searchFile5 | grep -i "$board2" | tail -n 1`  
        if [ -z "$BOARD" ]; then
          BOARD=`grep -i "$1" $searchFolder/$searchFile5 | grep -i "$board3" | tail -n 1`  
          if [ -z "$BOARD" ]; then
            BOARD=`grep -i "$1" $searchFolder/$searchFile5 | grep -i "$board4" | tail -n 1`  
            if [ -z "$BOARD" ]; then
              BOARD=`grep -i "$1" $searchFolder/$searchFile5 | grep -i "$board5" | tail -n 1`  
              if [ -z "$BOARD" ]; then
                BOARD=`grep -i "$1" $searchFolder/$searchFile5 | grep -i "$board6" | tail -n 1`  
                if [ -z "$BOARD" ]; then
                  BOARD=`grep -i "$1" $searchFolder/$searchFile5 | grep -i "$board7" | tail -n 1`  
                  if [ -z "$BOARD" ]; then
                    BOARD=`grep -i "$1" $searchFolder/$searchFile5 | grep -i "$board8" | tail -n 1`  
                    if [ -z "$BOARD" ]; then
                      BOARD=`grep -i "$1" $searchFolder/$searchFile5 | grep -i "$board9" | tail -n 1`  
                      if [ -z "$BOARD" ]; then
                        BOARD=`grep -i "$1" $searchFolder/$searchFile5 | grep -i "$board10" | tail -n 1`  
                        if [ -z "$BOARD" ]; then
                          BOARD=`grep -i "$1" $searchFolder/$searchFile5 | grep -i "$board11" | tail -n 1`
                          if [ -z "$BOARD" ]; then
                            BOARD=`grep -i "$1" $searchFolder/$searchFile5 | grep -i "$board12" | tail -n 1`  
                            if [ ! -z "$BOARD" ]; then
                              BOARD=$board12
                            fi
                          else 
                            BOARD=$board11
                          fi 
                        else
                          BOARD=$board10
                        fi   
                      else
                        BOARD=$board9
                      fi  
                    else
                      BOARD=$board8
                    fi   
                  else
                    BOARD=$board7
                  fi 
                else
                  BOARD=$board6
                fi 
              else
                BOARD=$board5
              fi 
            else
              BOARD=$board4
            fi  
          else
            BOARD=$board3            
          fi   
        else
          BOARD=$board2
        fi
      else
        BOARD=$board1
      fi
    fi     
  fi
  
  echo "$BOARD"
}

# $1 = boardString1, boardString2, boardString3
getResetBoardFile6()
{
  if [ ! -z $searchFile6 ]; then
    isTextInFile6 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then 
      #BOARD=`grep -i "$1" $searchFolder/$searchFile6 | grep -oP '\w+(?= '"$1"')' | tail -n 1`  
      BOARD=`grep -i "$1" $searchFolder/$searchFile6 | grep -i "$board1" | tail -n 1`  
      if [ -z "$BOARD" ]; then
        BOARD=`grep -i "$1" $searchFolder/$searchFile6 | grep -i "$board2" | tail -n 1`  
        if [ -z "$BOARD" ]; then
          BOARD=`grep -i "$1" $searchFolder/$searchFile6 | grep -i "$board3" | tail -n 1`  
          if [ -z "$BOARD" ]; then
            BOARD=`grep -i "$1" $searchFolder/$searchFile6 | grep -i "$board4" | tail -n 1`  
            if [ -z "$BOARD" ]; then
              BOARD=`grep -i "$1" $searchFolder/$searchFile6 | grep -i "$board5" | tail -n 1`  
              if [ -z "$BOARD" ]; then
                BOARD=`grep -i "$1" $searchFolder/$searchFile6 | grep -i "$board6" | tail -n 1`  
                if [ -z "$BOARD" ]; then
                  BOARD=`grep -i "$1" $searchFolder/$searchFile6 | grep -i "$board7" | tail -n 1`  
                  if [ -z "$BOARD" ]; then
                    BOARD=`grep -i "$1" $searchFolder/$searchFile6 | grep -i "$board8" | tail -n 1`  
                    if [ -z "$BOARD" ]; then
                      BOARD=`grep -i "$1" $searchFolder/$searchFile6 | grep -i "$board9" | tail -n 1`  
                      if [ -z "$BOARD" ]; then
                        BOARD=`grep -i "$1" $searchFolder/$searchFile6 | grep -i "$board10" | tail -n 1`  
                        if [ -z "$BOARD" ]; then
                          BOARD=`grep -i "$1" $searchFolder/$searchFile6 | grep -i "$board11" | tail -n 1`
                          if [ -z "$BOARD" ]; then
                            BOARD=`grep -i "$1" $searchFolder/$searchFile6 | grep -i "$board12" | tail -n 1`  
                            if [ ! -z "$BOARD" ]; then
                              BOARD=$board12
                            fi
                          else 
                            BOARD=$board11
                          fi 
                        else
                          BOARD=$board10
                        fi   
                      else
                        BOARD=$board9
                      fi  
                    else
                      BOARD=$board8
                    fi   
                  else
                    BOARD=$board7
                  fi 
                else
                  BOARD=$board6
                fi 
              else
                BOARD=$board5
              fi 
            else
              BOARD=$board4
            fi  
          else
            BOARD=$board3            
          fi   
        else
          BOARD=$board2
        fi
      else
        BOARD=$board1
      fi
    fi       
  fi
  
  echo "$BOARD"
}

getResetBoard()
{
  local res=$(getResetBoardFile1 "$boardString1")

  if [ ! -z "$res" ]; then
    BOARD_TYPE="$res"
  fi
  
  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile2 "$boardString1")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi
  
  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile3 "$boardString1")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi 
  
  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile4 "$boardString1")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi   
  
  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile5 "$boardString1")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi     

  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile6 "$boardString1")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi   
  
  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile1 "$boardString2")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi  
  
  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile2 "$boardString2")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi  

  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile3 "$boardString2")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi  
  
  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile4 "$boardString2")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi  
  
  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile5 "$boardString2")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi  
  
  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile6 "$boardString2")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi  
  
  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile1 "$boardString3")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi  
  
  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile2 "$boardString3")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi  

  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile3 "$boardString3")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi   

  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile4 "$boardString3")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi   
  
  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile5 "$boardString3")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi    
  
  if [[ "$BOARD_TYPE" == "unknown" ]]; then
    local res=$(getResetBoardFile6 "$boardString3")

    if [ ! -z "$res" ]; then
      BOARD_TYPE="$res"
    fi
  fi    
}

# $1 = boardStartString1, boardStartString2, boardStartString3
getResetDateFile1()
{
  if [ ! -z $searchFile1 ]; then
    isTextInFile1 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      for i in 4 3 2 1; do 
        VALID_MONTH=`grep -w "$1" $searchFolder/$searchFile1 2>/dev/null | tail -n 1 | awk "/^Jan|^Feb|^Mar|^Apr|^May|^Jun|^Jul|^Aug|^Sep|^Oct|^Nov|^Dec/"`
     
        if [ "$VALID_MONTH" != "" ]; then 
          DATE="`grep -w "$1" $searchFolder/$searchFile1 2>/dev/null | tail -n 1 | awk '{printf "%s %s %s\n", $1, $2, $3}'`"
          break
        else
          VALID_MONTH=`grep -w "$1" $searchFolder/$searchFile1 2>/dev/null | tail -n 1 | awk "/^Mon|^Tue|^Wed|^Thu|^Fri|^Sat|^Sun/"`
          
          if [ "$VALID_MONTH" != "" ]; then 
            DATE="`grep -w "$1" $searchFolder/$searchFile1 2>/dev/null | tail -n 1 | awk '{printf "%s %s %s %s\n", $1, $2, $3, $4}'`"
            break
          fi
        fi
      done
    fi
  fi
  
  echo "$DATE"
}

# $1 = boardStartString1, boardStartString2, boardStartString3
getResetDateFile2()
{
  if [ ! -z $searchFile2 ]; then
    isTextInFile2 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      for i in 4 3 2 1; do 
        VALID_MONTH=`grep -w "$1" $searchFolder/$searchFile2 2>/dev/null | tail -n 1 | awk "/^Jan|^Feb|^Mar|^Apr|^May|^Jun|^Jul|^Aug|^Sep|^Oct|^Nov|^Dec/"`
     
        if [ "$VALID_MONTH" != "" ]; then 
          DATE="`grep -w "$1" $searchFolder/$searchFile2 2>/dev/null | tail -n 1 | awk '{printf "%s %s %s\n", $1, $2, $3}'`"
          break
        else
          VALID_MONTH=`grep -w "$1" $searchFolder/$searchFile2 2>/dev/null | tail -n 1 | awk "/^Mon|^Tue|^Wed|^Thu|^Fri|^Sat|^Sun/"`
          
          if [ "$VALID_MONTH" != "" ]; then 
            DATE="`grep -w "$1" $searchFolder/$searchFile2 2>/dev/null | tail -n 1 | awk '{printf "%s %s %s %s\n", $1, $2, $3, $4}'`"
            break
          fi          
        fi
      done
    fi
  fi
  
  echo "$DATE"
}

# $1 = boardStartString1, boardStartString2, boardStartString3
getResetDateFile3()
{
  if [ ! -z $searchFile3 ]; then
    isTextInFile3 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      for i in 4 3 2 1; do 
        VALID_MONTH=`grep -w "$1" $searchFolder/$searchFile3 2>/dev/null | tail -n 1 | awk "/^Jan|^Feb|^Mar|^Apr|^May|^Jun|^Jul|^Aug|^Sep|^Oct|^Nov|^Dec/"`
     
        if [ "$VALID_MONTH" != "" ]; then 
          DATE="`grep -w "$1" $searchFolder/$searchFile3 2>/dev/null | tail -n 1 | awk '{printf "%s %s %s\n", $1, $2, $3}'`"
          break
        else
          VALID_MONTH=`grep -w "$1" $searchFolder/$searchFile3 2>/dev/null | tail -n 1 | awk "/^Mon|^Tue|^Wed|^Thu|^Fri|^Sat|^Sun/"`
          
          if [ "$VALID_MONTH" != "" ]; then 
            DATE="`grep -w "$1" $searchFolder/$searchFile3 2>/dev/null | tail -n 1 | awk '{printf "%s %s %s %s\n", $1, $2, $3, $4}'`"
            break
          fi          
        fi
      done
    fi
  fi
  
  echo "$DATE"
}

# $1 = boardStartString1, boardStartString2, boardStartString3
getResetDateFile4()
{
  if [ ! -z $searchFile4 ]; then
    isTextInFile4 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      for i in 4 3 2 1; do 
        VALID_MONTH=`grep -w "$1" $searchFolder/$searchFile4 2>/dev/null | tail -n 1 | awk "/^Jan|^Feb|^Mar|^Apr|^May|^Jun|^Jul|^Aug|^Sep|^Oct|^Nov|^Dec/"`
     
        if [ "$VALID_MONTH" != "" ]; then 
          DATE="`grep -w "$1" $searchFolder/$searchFile4 2>/dev/null | tail -n 1 | awk '{printf "%s %s %s\n", $1, $2, $3}'`"
          break
        else
          VALID_MONTH=`grep -w "$1" $searchFolder/$searchFile4 2>/dev/null | tail -n 1 | awk "/^Mon|^Tue|^Wed|^Thu|^Fri|^Sat|^Sun/"`
          
          if [ "$VALID_MONTH" != "" ]; then 
            DATE="`grep -w "$1" $searchFolder/$searchFile4 2>/dev/null | tail -n 1 | awk '{printf "%s %s %s %s\n", $1, $2, $3, $4}'`"
            break
          fi  
        fi          
      done
    fi
  fi
  
  echo "$DATE"
}

# $1 = boardStartString1, boardStartString2, boardStartString3
getResetDateFile5()
{
  if [ ! -z $searchFile5 ]; then
    isTextInFile5 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      for i in 4 3 2 1; do 
        VALID_MONTH=`grep -w "$1" $searchFolder/$searchFile5 2>/dev/null | tail -n 1 | awk "/^Jan|^Feb|^Mar|^Apr|^May|^Jun|^Jul|^Aug|^Sep|^Oct|^Nov|^Dec/"`
     
        if [ "$VALID_MONTH" != "" ]; then 
          DATE="`grep -w "$1" $searchFolder/$searchFile5 2>/dev/null | tail -n 1 | awk '{printf "%s %s %s\n", $1, $2, $3}'`"
          break
        else
          VALID_MONTH=`grep -w "$1" $searchFolder/$searchFile5 2>/dev/null | tail -n 1 | awk "/^Mon|^Tue|^Wed|^Thu|^Fri|^Sat|^Sun/"`
          
          if [ "$VALID_MONTH" != "" ]; then 
            DATE="`grep -w "$1" $searchFolder/$searchFile5 2>/dev/null | tail -n 1 | awk '{printf "%s %s %s %s\n", $1, $2, $3, $4}'`"
            break
          fi          
        fi
      done
    fi
  fi
  
  echo "$DATE"
}

# $1 = boardStartString1, boardStartString2, boardStartString3
getResetDateFile6()
{
  if [ ! -z $searchFile6 ]; then
    isTextInFile6 "$1"
    local count=$? 
    
    if [ ! $count -eq 0 ]; then
      for i in 4 3 2 1; do 
        VALID_MONTH=`grep -w "$1" $searchFolder/$searchFile6 2>/dev/null | tail -n 1 | awk "/^Jan|^Feb|^Mar|^Apr|^May|^Jun|^Jul|^Aug|^Sep|^Oct|^Nov|^Dec/"`
     
        if [ "$VALID_MONTH" != "" ]; then 
          DATE="`grep -w "$1" $searchFolder/$searchFile6 2>/dev/null | tail -n 1 | awk '{printf "%s %s %s\n", $1, $2, $3}'`"
          break
        else
          VALID_MONTH=`grep -w "$1" $searchFolder/$searchFile6 2>/dev/null | tail -n 1 | awk "/^Mon|^Tue|^Wed|^Thu|^Fri|^Sat|^Sun/"`
          
          if [ "$VALID_MONTH" != "" ]; then 
            DATE="`grep -w "$1" $searchFolder/$searchFile6 2>/dev/null | tail -n 1 | awk '{printf "%s %s %s %s\n", $1, $2, $3, $4}'`"
            break
          fi          
        fi
      done
    fi
  fi
  
  echo "$DATE"
}

getResetDate()
{
  local res=$(getResetDateFile1 "$boardStartString1")

  if [ ! -z "$res" ]; then
    RESET_DATE="$res"
  fi
  
  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile2 "$boardStartString1")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi
  
  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile3 "$boardStartString1")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi 
  
  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile4 "$boardStartString1")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi 

  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile5 "$boardStartString1")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi 
  
  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile6 "$boardStartString1")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi   

  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile1 "$boardStartString2")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi  
  
  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile2 "$boardStartString2")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi  

  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile3 "$boardStartString2")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi  
  
  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile4 "$boardStartString2")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi    
  
  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile5 "$boardStartString2")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi    
  
  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile6 "$boardStartString2")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi  
  
  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile1 "$boardStartString3")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi  
  
  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile2 "$boardStartString3")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi  

  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile3 "$boardStartString3")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi   
  
  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile4 "$boardStartString3")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi   

  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile5 "$boardStartString3")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi  
  
  if [[ "$RESET_DATE" == "unknown" ]]; then
    local res=$(getResetDateFile6 "$boardStartString3")

    if [ ! -z "$res" ]; then
      RESET_DATE="$res"
    fi
  fi    
}

isTextInFile1()
{
  if [ ! -z "$1" ]; then
    if [ ! -z "$searchFile1" ]; then
      return $(grep -c "$1" $searchFolder/$searchFile1 2>/dev/null | tail -n 1)
    fi      
  fi
  
  return 0
}

isTextInFile2()
{
  if [ ! -z "$1" ]; then 
    if [ ! -z $searchFile2 ]; then
      return $(grep -c "$1" $searchFolder/$searchFile2 2>/dev/null | tail -n 1)
    fi       
  fi
  
  return 0
}

isTextInFile3()
{
  if [ ! -z "$1" ]; then
    if [ ! -z $searchFile3 ]; then
      return $(grep -c "$1" $searchFolder/$searchFile3 2>/dev/null | tail -n 1)
    fi      
  fi
  
  return 0
}

isTextInFile4()
{
  if [ ! -z "$1" ]; then
    if [ ! -z $searchFile4 ]; then
      return $(grep -c "$1" $searchFolder/$searchFile4 2>/dev/null | tail -n 1)
    fi      
  fi
  
  return 0
}

isTextInFile5()
{
  if [ ! -z "$1" ]; then
    if [ ! -z $searchFile5 ]; then
      return $(grep -c "$1" $searchFolder/$searchFile5 2>/dev/null | tail -n 1)
    fi     
  fi
  
  return 0
}

isTextInFile6()
{
  if [ ! -z "$1" ]; then
    if [ ! -z $searchFile6 ]; then
      return $(grep -c "$1" $searchFolder/$searchFile6 2>/dev/null | tail -n 1)
    fi 
  fi
  
  return 0
}

# $1 = searchString1
# $2 = string1MaxLineNumbers
getResetReasonFile1()
{ 
  if [ ! -z "$1" ]; then
    isTextInFile1 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      num=$(($2 + 1))
      
      REASON1=""
      if [ ! -z $searchFile1 ]; then
        REASON1=$(grep -i -A $2 "$1" $searchFolder/$searchFile1 2>/dev/null | tail -n $num)
      fi
    
      REASON=`printf "%s\n" "$REASON1"`
      if [[ $DEBUG == 1 ]]; then
        echo "[getResetReasonFile1] REASON1=" $REASON1
        echo ""
      fi
    fi
  fi
    
  if [[ $DEBUG == 1 ]]; then
    echo "[getResetReasonFile1] REASON=" $REASON
    echo ""
  fi
  
  echo "$REASON"
}

# $1 = searchString1
# $2 = string1MaxLineNumbers
getResetReasonFile2()
{ 
  if [ ! -z "$1" ]; then
    isTextInFile2 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      num=$(($2 + 1))
      
      REASON1=""
      if [ ! -z $searchFile2 ]; then
        REASON1=$(grep -i -A $2 "$1" $searchFolder/$searchFile2 2>/dev/null | tail -n $num)
      fi      
    
      REASON=`printf "%s\n" "$REASON1"`
      if [[ $DEBUG == 1 ]]; then
        echo "[getResetReasonFile2] REASON1=" $REASON1
        echo ""
      fi
    fi
  fi
    
  if [[ $DEBUG == 1 ]]; then
    echo "[getResetReasonFile2] REASON=" $REASON
    echo ""
  fi
  
  echo "$REASON"
}

# $1 = searchString1
# $2 = string1MaxLineNumbers
getResetReasonFile3()
{ 
  if [ ! -z "$1" ]; then
    isTextInFile3 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      num=$(($2 + 1))
      
      REASON1=""
      if [ ! -z $searchFile3 ]; then
        REASON1=$(grep -i -A $2 "$1" $searchFolder/$searchFile3 2>/dev/null | tail -n $num)
      fi       
    
      REASON=`printf "%s\n" "$REASON1"`
      if [[ $DEBUG == 1 ]]; then
        echo "[getResetReasonFile3] REASON1=" $REASON1
        echo ""
      fi
    fi
  fi
    
  if [[ $DEBUG == 1 ]]; then
    echo "[getResetReasonFile3] REASON=" $REASON
    echo ""
  fi
  
  echo "$REASON"
}

# $1 = searchString1
# $2 = string1MaxLineNumbers
getResetReasonFile4()
{ 
  if [ ! -z "$1" ]; then
    isTextInFile4 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      num=$(($2 + 1))
      
      REASON1=""
      if [ ! -z $searchFile4 ]; then
        REASON1=$(grep -i -A $2 "$1" $searchFolder/$searchFile4 2>/dev/null | tail -n $num)
      fi        
    
      REASON=`printf "%s\n" "$REASON1"`
      if [[ $DEBUG == 1 ]]; then
        echo "[getResetReasonFile4] REASON1=" $REASON1
        echo ""
      fi
    fi
  fi
    
  if [[ $DEBUG == 1 ]]; then
    echo "[getResetReasonFile4] REASON=" $REASON
    echo ""
  fi
  
  echo "$REASON"
}

# $1 = searchString1
# $2 = string1MaxLineNumbers
getResetReasonFile5()
{ 
  if [ ! -z "$1" ]; then
    isTextInFile5 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      num=$(($2 + 1))
      
      REASON1=""
      if [ ! -z $searchFile5 ]; then
        REASON1=$(grep -i -A $2 "$1" $searchFolder/$searchFile5 2>/dev/null | tail -n $num)
      fi      
    
      REASON=`printf "%s\n" "$REASON1"`
      if [[ $DEBUG == 1 ]]; then
        echo "[getResetReasonFile5] REASON1=" $REASON1
        echo ""
      fi
    fi
  fi
    
  if [[ $DEBUG == 1 ]]; then
    echo "[getResetReasonFile5] REASON=" $REASON
    echo ""
  fi
  
  echo "$REASON"
}

# $1 = searchString1
# $2 = string1MaxLineNumbers
getResetReasonFile6()
{ 
  if [ ! -z "$1" ]; then
    isTextInFile6 "$1"
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      num=$(($2 + 1))
      
      REASON1=""
      if [ ! -z $searchFile6 ]; then
        REASON1=$(grep -i -A $2 "$1" $searchFolder/$searchFile6 2>/dev/null | tail -n $num)
      fi       
    
      REASON=`printf "%s\n" "$REASON1"`
      if [[ $DEBUG == 1 ]]; then
        echo "[getResetReasonFile6] REASON1=" $REASON1
        echo ""
      fi
    fi
  fi
    
  if [[ $DEBUG == 1 ]]; then
    echo "[getResetReasonFile6] REASON=" $REASON
    echo ""
  fi
  
  echo "$REASON"
}

FOUND=1
getResetReason()
{
  FOUND=0
  FOUNDCOUNT=0
  STRINGCOUNT=0
  
  if [ ! -z "$searchString1" ]; then
    STRINGCOUNT=1
  fi
  if [ ! -z "$searchString2" ]; then
    STRINGCOUNT=2
  fi
  if [ ! -z "$searchString3" ]; then
    STRINGCOUNT=3
  fi  
  
  local res=$(getResetReasonFile1 "$searchString1" $string1MaxLineNumbers)

  if [ ! -z "$res" ]; then
    RESET_REASON="$res"
    FOUND=1
    FOUNDCOUNT=1
  else
    local res=$(getResetReasonFile2 "$searchString1" $string1MaxLineNumbers)
    
    if [ ! -z "$res" ]; then
      RESET_REASON="$res"
      FOUND=1
      FOUNDCOUNT=1
    else
      local res=$(getResetReasonFile3 "$searchString1" $string1MaxLineNumbers) 
      
      if [ ! -z "$res" ]; then
        RESET_REASON="$res"
        FOUND=1
        FOUNDCOUNT=1
        
      else
        local res=$(getResetReasonFile4 "$searchString1" $string1MaxLineNumbers) 
      
        if [ ! -z "$res" ]; then
          RESET_REASON="$res"
          FOUND=1
          FOUNDCOUNT=1
          
        else
          local res=$(getResetReasonFile5 "$searchString1" $string1MaxLineNumbers) 
        
          if [ ! -z "$res" ]; then
            RESET_REASON="$res"
            FOUND=1
            FOUNDCOUNT=1
            
          else
            local res=$(getResetReasonFile6 "$searchString1" $string1MaxLineNumbers) 
          
            if [ ! -z "$res" ]; then
              RESET_REASON="$res"
              FOUND=1
              FOUNDCOUNT=1
            fi            
          fi           
        fi   
      fi      
    fi
  fi
  
  if [[ $allSearchString == 1 ]]; then
    if [[ $FOUND == 1 ]]; then
      FOUND=0
      if [ ! -z "$searchString2" ]; then
        FOUND=1
      fi
      local res=$(getResetReasonFile1 "$searchString2" $string2MaxLineNumbers)

      if [ ! -z "$res" ]; then
        RESET_REASON+="$res"
        FOUND=1
        FOUNDCOUNT=2
      else
        local res=$(getResetReasonFile2 "$searchString2" $string2MaxLineNumbers)
        
        if [ ! -z "$res" ]; then
          RESET_REASON+="$res"
          FOUND=1
          FOUNDCOUNT=2
        else
          local res=$(getResetReasonFile3 "$searchString2" $string2MaxLineNumbers) 
          
          if [ ! -z "$res" ]; then
            RESET_REASON+="$res"
            FOUND=1
            FOUNDCOUNT=2  
          else 
            local res=$(getResetReasonFile4 "$searchString2" $string2MaxLineNumbers) 
            
            if [ ! -z "$res" ]; then
              RESET_REASON+="$res"
              FOUND=1
              FOUNDCOUNT=2  
            else 
              local res=$(getResetReasonFile5 "$searchString2" $string2MaxLineNumbers) 
              
              if [ ! -z "$res" ]; then
                RESET_REASON+="$res"
                FOUND=1
                FOUNDCOUNT=2  
              else 
                local res=$(getResetReasonFile6 "$searchString2" $string2MaxLineNumbers) 
                
                if [ ! -z "$res" ]; then
                  RESET_REASON+="$res"
                  FOUND=1
                  FOUNDCOUNT=2  
                fi                
              fi               
            fi             
          fi      
        fi
      fi      
    
      if [[ $FOUND == 1 ]]; then
        FOUND=0
        if [ ! -z "$searchString3" ]; then
          FOUND=1
        fi
        local res=$(getResetReasonFile1 "$searchString3" $string3MaxLineNumbers)

        if [ ! -z "$res" ]; then
          RESET_REASON+="$res"
          FOUND=1
          FOUNDCOUNT=3
        else
          local res=$(getResetReasonFile2 "$searchString3" $string3MaxLineNumbers)
          
          if [ ! -z "$res" ]; then
            RESET_REASON+="$res"
            FOUND=1
            FOUNDCOUNT=3
          else
            local res=$(getResetReasonFile3 "$searchString3" $string3MaxLineNumbers) 
            
            if [ ! -z "$res" ]; then
              RESET_REASON+="$res"
              FOUND=1
              FOUNDCOUNT=3
            else
              local res=$(getResetReasonFile4 "$searchString3" $string3MaxLineNumbers) 
              
              if [ ! -z "$res" ]; then
                RESET_REASON+="$res"
                FOUND=1
                FOUNDCOUNT=3
              else
                local res=$(getResetReasonFile5 "$searchString3" $string3MaxLineNumbers) 
                
                if [ ! -z "$res" ]; then
                  RESET_REASON+="$res"
                  FOUND=1
                  FOUNDCOUNT=3
                else
                  local res=$(getResetReasonFile6 "$searchString3" $string3MaxLineNumbers) 
                  
                  if [ ! -z "$res" ]; then
                    RESET_REASON+="$res"
                    FOUND=1
                    FOUNDCOUNT=3
                  fi                 
                fi               
              fi                
            fi      
          fi
        fi          
      fi
    fi
    
    if [[ $FOUNDCOUNT != $STRINGCOUNT ]]; then
      RESET_REASON="No information available on reset!"
    fi
  else
    local res=$(getResetReasonFile1 "$searchString2" $string2MaxLineNumbers)

    if [ ! -z "$res" ]; then
      RESET_REASON+="$res"
    else
      local res=$(getResetReasonFile2 "$searchString2" $string2MaxLineNumbers)
      
      if [ ! -z "$res" ]; then
        RESET_REASON+="$res"
      else
        local res=$(getResetReasonFile3 "$searchString2" $string2MaxLineNumbers) 
        
        if [ ! -z "$res" ]; then
          RESET_REASON+="$res"
        else
          local res=$(getResetReasonFile4 "$searchString2" $string2MaxLineNumbers) 
          
          if [ ! -z "$res" ]; then
            RESET_REASON+="$res"
          else
            local res=$(getResetReasonFile5 "$searchString2" $string2MaxLineNumbers) 
            
            if [ ! -z "$res" ]; then
              RESET_REASON+="$res"
            else
              local res=$(getResetReasonFile6 "$searchString2" $string2MaxLineNumbers) 
              
              if [ ! -z "$res" ]; then
                RESET_REASON+="$res"
              fi              
            fi            
          fi          
        fi      
      fi
    fi  
    
    local res=$(getResetReasonFile1 "$searchString3" $string3MaxLineNumbers)

    if [ ! -z "$res" ]; then
      RESET_REASON+="$res"
    else
      local res=$(getResetReasonFile2 "$searchString3" $string3MaxLineNumbers)
      
      if [ ! -z "$res" ]; then
        RESET_REASON+="$res"
      else
        local res=$(getResetReasonFile3 "$searchString3" $string3MaxLineNumbers) 
        
        if [ ! -z "$res" ]; then
          RESET_REASON+="$res"
        else
          local res=$(getResetReasonFile4 "$searchString3" $string3MaxLineNumbers) 
          
          if [ ! -z "$res" ]; then
            RESET_REASON+="$res"
          else
            local res=$(getResetReasonFile5 "$searchString3" $string3MaxLineNumbers) 
            
            if [ ! -z "$res" ]; then
              RESET_REASON+="$res"
            else
              local res=$(getResetReasonFile6 "$searchString3" $string3MaxLineNumbers) 
              
              if [ ! -z "$res" ]; then
                RESET_REASON+="$res"
              fi               
            fi               
          fi           
        fi      
      fi
    fi    
  fi
  
  if [[ "$RESET_REASON" != "No information available on reset!" ]]; then
    if [ ! -z "$command1" ]; then
      eval "$command1"
      if [ ! -z "$command2" ]; then
        eval "$command2"
        if [ ! -z "$command3" ]; then
          eval "$command3"
          if [ ! -z "$command4" ]; then
            eval "$command4"
            if [ ! -z "$command5" ]; then
              eval "$command5"
              if [ ! -z "$command6" ]; then
                eval "$command6"
                if [ ! -z "$command7" ]; then
                  eval "$command7"
                  if [ ! -z "$command8" ]; then
                    eval "$command8"
                    if [ ! -z "$command9" ]; then
                      eval "$command9"
                      if [ ! -z "$command10" ]; then
                        eval "$command10"
                      fi                        
                    fi                       
                  fi                     
                fi                    
              fi                  
            fi            
          fi          
        fi        
      fi
    fi
  fi
  
  if [[ "$FOUND" == "0" ]]; then
    RESET_REASON="No information available on reset!"
  fi 
}

# $1 = coreDumpSearchString1
# $2 = coreDumpString1MaxLineNumbers
getCoreDumpFile1()
{ 
  if [ ! -z "$1" ]; then
    isTextInFile1 $1
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      num=$(($2 + 1))
      
      DUMP1=""
      if [ ! -z $searchFile1 ]; then
        DUMP1=$(grep -i -A $2 "$1" $searchFolder/$searchFile1 2>/dev/null | tail -n $num)
      fi        
    
      DUMP=`printf "%s\n" "$DUMP1"`
      if [[ $DEBUG == 1 ]]; then
        echo "[getCoreDumpFile1] DUMP1=" $DUMP1 
        echo ""
      fi
    fi
  fi
   
  if [[ $DEBUG == 1 ]]; then
    echo "[getCoreDumpFile1] DUMP=" $DUMP
    echo ""
  fi
  
  echo "$DUMP"
}

# $1 = coreDumpSearchString1
# $2 = coreDumpString1MaxLineNumbers
getCoreDumpFile2()
{ 
  if [ ! -z "$1" ]; then
    isTextInFile2 $1
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      num=$(($2 + 1))
      
      DUMP1=""
      if [ ! -z $searchFile2 ]; then
        DUMP1=$(grep -i -A $2 "$1" $searchFolder/$searchFile2 2>/dev/null | tail -n $num)
      fi         
    
      DUMP=`printf "%s\n" "$DUMP1"`
      if [[ $DEBUG == 1 ]]; then
        echo "[getCoreDumpFile2] DUMP1=" $DUMP1 
        echo ""
      fi
    fi
  fi
   
  if [[ $DEBUG == 1 ]]; then
    echo "[getCoreDumpFile2] DUMP=" $DUMP
    echo ""
  fi
  
  echo "$DUMP"
}

# $1 = coreDumpSearchString1
# $2 = coreDumpString1MaxLineNumbers
getCoreDumpFile3()
{ 
  if [ ! -z "$1" ]; then
    isTextInFile3 $1
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      num=$(($2 + 1))
      
      DUMP1=""
      if [ ! -z $searchFile3 ]; then
        DUMP1=$(grep -i -A $2 "$1" $searchFolder/$searchFile3 2>/dev/null | tail -n $num)
      fi       
    
      DUMP=`printf "%s\n" "$DUMP1"`
      if [[ $DEBUG == 1 ]]; then
        echo "[getCoreDumpFile3] DUMP1=" $DUMP1 
        echo ""
      fi
    fi
  fi
   
  if [[ $DEBUG == 1 ]]; then
    echo "[getCoreDumpFile3] DUMP=" $DUMP
    echo ""
  fi
  
  echo "$DUMP"
}

# $1 = coreDumpSearchString1
# $2 = coreDumpString1MaxLineNumbers
getCoreDumpFile4()
{ 
  if [ ! -z "$1" ]; then
    isTextInFile4 $1
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      num=$(($2 + 1))
      
      DUMP1=""
      if [ ! -z $searchFile4 ]; then
        DUMP1=$(grep -i -A $2 "$1" $searchFolder/$searchFile4 2>/dev/null | tail -n $num)
      fi       
    
      DUMP=`printf "%s\n" "$DUMP1"`
      if [[ $DEBUG == 1 ]]; then
        echo "[getCoreDumpFile4] DUMP1=" $DUMP1 
        echo ""
      fi
    fi
  fi
   
  if [[ $DEBUG == 1 ]]; then
    echo "[getCoreDumpFile4] DUMP=" $DUMP
    echo ""
  fi
  
  echo "$DUMP"
}

# $1 = coreDumpSearchString1
# $2 = coreDumpString1MaxLineNumbers
getCoreDumpFile5()
{ 
  if [ ! -z "$1" ]; then
    isTextInFile5 $1
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      num=$(($2 + 1))
      
      DUMP1=""
      if [ ! -z $searchFile5 ]; then
        DUMP1=$(grep -i -A $2 "$1" $searchFolder/$searchFile5 2>/dev/null | tail -n $num)
      fi      
    
      DUMP=`printf "%s\n" "$DUMP1"`
      if [[ $DEBUG == 1 ]]; then
        echo "[getCoreDumpFile5] DUMP1=" $DUMP1 
        echo ""
      fi
    fi
  fi
   
  if [[ $DEBUG == 1 ]]; then
    echo "[getCoreDumpFile5] DUMP=" $DUMP
    echo ""
  fi
  
  echo "$DUMP"
}

# $1 = coreDumpSearchString1
# $2 = coreDumpString1MaxLineNumbers
getCoreDumpFile6()
{ 
  if [ ! -z "$1" ]; then
    isTextInFile6 $1
    local count=$?
    
    if [ ! $count -eq 0 ]; then
      num=$(($2 + 1))
      
      DUMP1=""
      if [ ! -z $searchFile6 ]; then
        DUMP1=$(grep -i -A $2 "$1" $searchFolder/$searchFile6 2>/dev/null | tail -n $num)
      fi       
    
      DUMP=`printf "%s\n" "$DUMP1"`
      if [[ $DEBUG == 1 ]]; then
        echo "[getCoreDumpFile6] DUMP1=" $DUMP1 
        echo ""
      fi
    fi
  fi
   
  if [[ $DEBUG == 1 ]]; then
    echo "[getCoreDumpFile6] DUMP=" $DUMP
    echo ""
  fi
  
  echo "$DUMP"
}

getCoreDump()
{
  if [[ $coreDump == 1 ]]; then
    local res=$(getCoreDumpFile1 "$coreDumpSearchString1" $coreDumpString1MaxLineNumbers)

    if [ ! -z "$res" ]; then
      CORE_DUMP="$res"
    else
      local res=$(getCoreDumpFile2 "$coreDumpSearchString1" $coreDumpString1MaxLineNumbers)
      
      if [ ! -z "$res" ]; then
        CORE_DUMP="$res"
      else
        local res=$(getCoreDumpFile3 "$coreDumpSearchString1" $coreDumpString1MaxLineNumbers) 
        
        if [ ! -z "$res" ]; then
          CORE_DUMP="$res"
        else
          local res=$(getCoreDumpFile4 "$coreDumpSearchString1" $coreDumpString1MaxLineNumbers) 
          
          if [ ! -z "$res" ]; then
            CORE_DUMP="$res"
          else
            local res=$(getCoreDumpFile5 "$coreDumpSearchString1" $coreDumpString1MaxLineNumbers) 
            
            if [ ! -z "$res" ]; then
              CORE_DUMP="$res"
            else
              local res=$(getCoreDumpFile6 "$coreDumpSearchString1" $coreDumpString1MaxLineNumbers) 
              
              if [ ! -z "$res" ]; then
                CORE_DUMP="$res"
              fi                
            fi             
          fi           
        fi      
      fi
    fi  
  
    local res=$(getCoreDumpFile1 "$coreDumpSearchString2" $coreDumpString2MaxLineNumbers)

    if [ ! -z "$res" ]; then
      CORE_DUMP+="$res"
    else
      local res=$(getCoreDumpFile2 "$coreDumpSearchString2" $coreDumpString2MaxLineNumbers)
      
      if [ ! -z "$res" ]; then
        CORE_DUMP+="$res"
      else
        local res=$(getCoreDumpFile3 "$coreDumpSearchString2" $coreDumpString2MaxLineNumbers) 
        
        if [ ! -z "$res" ]; then
          CORE_DUMP+="$res"
        else
          local res=$(getCoreDumpFile4 "$coreDumpSearchString2" $coreDumpString2MaxLineNumbers) 
          
          if [ ! -z "$res" ]; then
            CORE_DUMP+="$res"
          else
            local res=$(getCoreDumpFile5 "$coreDumpSearchString2" $coreDumpString2MaxLineNumbers) 
            
            if [ ! -z "$res" ]; then
              CORE_DUMP+="$res"
            else
              local res=$(getCoreDumpFile6 "$coreDumpSearchString2" $coreDumpString2MaxLineNumbers) 
              
              if [ ! -z "$res" ]; then
                CORE_DUMP+="$res"
              fi              
            fi               
          fi          
        fi      
      fi
    fi  

    local res=$(getCoreDumpFile1 "$coreDumpSearchString3" $coreDumpString3MaxLineNumbers)

    if [ ! -z "$res" ]; then
      CORE_DUMP+="$res"
    else
      local res=$(getCoreDumpFile2 "$coreDumpSearchString3" $coreDumpString3MaxLineNumbers)
      
      if [ ! -z "$res" ]; then
        CORE_DUMP+="$res"
      else
        local res=$(getCoreDumpFile3 "$coreDumpSearchString3" $coreDumpString3MaxLineNumbers) 
        
        if [ ! -z "$res" ]; then
          CORE_DUMP+="$res"
        else
          local res=$(getCoreDumpFile4 "$coreDumpSearchString3" $coreDumpString3MaxLineNumbers) 
          
          if [ ! -z "$res" ]; then
            CORE_DUMP+="$res"
          else
            local res=$(getCoreDumpFile5 "$coreDumpSearchString3" $coreDumpString3MaxLineNumbers) 
            
            if [ ! -z "$res" ]; then
              CORE_DUMP+="$res"
            else
              local res=$(getCoreDumpFile6 "$coreDumpSearchString3" $coreDumpString3MaxLineNumbers) 
              
              if [ ! -z "$res" ]; then
                CORE_DUMP+="$res"
              fi              
            fi            
          fi           
        fi      
      fi
    fi  
  fi
}

fileLen()
{
   if which stat >/dev/null 2>&1; then 
      stat -c %s $1 2>/dev/null
   else
      ls -l $1 2>/dev/null |awk '{print $5}'
   fi
}

checkCPUCore()
{
  FOUND="false"
  if [ ! -z "$1" ]; then
    if [ "$1" == "$CORE1" ]; then
      FOUND="true"
    fi
    if [ "$1" == "$CORE2" ]; then
      FOUND="true"
    fi  
    if [ "$1" == "$CORE3" ]; then
      FOUND="true"
    fi
    if [ "$1" == "$CORE4" ]; then
      FOUND="true"
    fi
  fi
  
  echo "$FOUND"
}

checkDtrc()
{
  if [[ $checkDtrc == 1 ]]; then
     #search for valid dtrc's...
     if [ ! -z $searchFile1 ]; then
       for D in `awk '/ERR_DTRC_SAV_DTRC/ {print $7 $11}' $searchFolder/$searchFile1`; do 
          #Jan 20 08:44:11 s_devlog@(none) dtrc: ERR_DTRC_SAV_DTRC 1,  START: 30030010,  LENGHT: 00021640
          #awk output: 1,00021640
          DTRC_NUM=`echo $D|cut -d, -f1`
          DTRC_LEN=`echo $D|cut -d, -f2|sed 's/^0*//'|tr -d '\r'`
          DTRC_LEN=`printf "%d" 0x$DTRC_LEN`
          #now look if dtrc on disk corespondes to this data
          [ "$POS" = "" ] && BOARD_POS="??" || BOARD_POS=$POS
          #[ "$BOARD" != "SPA" ] && BOARD_POS="00"
          DTRC_SUFFIX="$BOARD_POS$DTRC_NUM"
          for DTRC_FILE in `ls "$searchFolder"/dtrc/dtrc.$DTRC_SUFFIX 2>/dev/null`; do #use ls to expand .??x 
             [ "`fileLen $DTRC_FILE`" = "$DTRC_LEN" ] && VALID_DTRCS="$VALID_DTRCS"" $DTRC_FILE"
          done 
       done
     fi
     
      if [ -z "$VALID_DTRCS" ]; then
         #search for valid dtrc's...
         if [ ! -z $searchFile2 ]; then
          for D in `awk '/ERR_DTRC_SAV_DTRC/ {print $7 $11}' $searchFolder/$searchFile2`; do 
            #Jan 20 08:44:11 s_devlog@(none) dtrc: ERR_DTRC_SAV_DTRC 1,  START: 30030010,  LENGHT: 00021640
            #awk output: 1,00021640
            DTRC_NUM=`echo $D|cut -d, -f1`
            DTRC_LEN=`echo $D|cut -d, -f2|sed 's/^0*//'|tr -d '\r'`
            DTRC_LEN=`printf "%d" 0x$DTRC_LEN`
            #now look if dtrc on disk corespondes to this data
            [ "$POS" = "" ] && BOARD_POS="??" || BOARD_POS=$POS
            #[ "$BOARD" != "SPA" ] && BOARD_POS="00"
            DTRC_SUFFIX="$BOARD_POS$DTRC_NUM"
            for DTRC_FILE in `ls "$searchFolder"/dtrc/dtrc.$DTRC_SUFFIX 2>/dev/null`; do #use ls to expand .??x 
               [ "`fileLen $DTRC_FILE`" = "$DTRC_LEN" ] && VALID_DTRCS="$VALID_DTRCS"" $DTRC_FILE"
            done 
          done
        fi
        
        if [ -z "$VALID_DTRCS" ]; then
           #search for valid dtrc's...
           if [ ! -z $searchFile3 ]; then
            for D in `awk '/ERR_DTRC_SAV_DTRC/ {print $7 $11}' $searchFolder/$searchFile3`; do 
              #Jan 20 08:44:11 s_devlog@(none) dtrc: ERR_DTRC_SAV_DTRC 1,  START: 30030010,  LENGHT: 00021640
              #awk output: 1,00021640
              DTRC_NUM=`echo $D|cut -d, -f1`
              DTRC_LEN=`echo $D|cut -d, -f2|sed 's/^0*//'|tr -d '\r'`
              DTRC_LEN=`printf "%d" 0x$DTRC_LEN`
              #now look if dtrc on disk corespondes to this data
              [ "$POS" = "" ] && BOARD_POS="??" || BOARD_POS=$POS
              #[ "$BOARD" != "SPA" ] && BOARD_POS="00"
              DTRC_SUFFIX="$BOARD_POS$DTRC_NUM"
              for DTRC_FILE in `ls "$searchFolder"/dtrc/dtrc.$DTRC_SUFFIX 2>/dev/null`; do #use ls to expand .??x 
                 [ "`fileLen $DTRC_FILE`" = "$DTRC_LEN" ] && VALID_DTRCS="$VALID_DTRCS"" $DTRC_FILE"
              done 
            done
          fi
          
          if [ -z "$VALID_DTRCS" ]; then
             #search for valid dtrc's...
             if [ ! -z $searchFile4 ]; then
              for D in `awk '/ERR_DTRC_SAV_DTRC/ {print $7 $11}' $searchFolder/$searchFile4`; do 
                #Jan 20 08:44:11 s_devlog@(none) dtrc: ERR_DTRC_SAV_DTRC 1,  START: 30030010,  LENGHT: 00021640
                #awk output: 1,00021640
                DTRC_NUM=`echo $D|cut -d, -f1`
                DTRC_LEN=`echo $D|cut -d, -f2|sed 's/^0*//'|tr -d '\r'`
                DTRC_LEN=`printf "%d" 0x$DTRC_LEN`
                #now look if dtrc on disk corespondes to this data
                [ "$POS" = "" ] && BOARD_POS="??" || BOARD_POS=$POS
                #[ "$BOARD" != "SPA" ] && BOARD_POS="00"
                DTRC_SUFFIX="$BOARD_POS$DTRC_NUM"
                for DTRC_FILE in `ls "$searchFolder"/dtrc/dtrc.$DTRC_SUFFIX 2>/dev/null`; do #use ls to expand .??x 
                   [ "`fileLen $DTRC_FILE`" = "$DTRC_LEN" ] && VALID_DTRCS="$VALID_DTRCS"" $DTRC_FILE"
                done 
              done
            fi
            
            if [ -z "$VALID_DTRCS" ]; then
               #search for valid dtrc's...
               if [ ! -z $searchFile5 ]; then
                for D in `awk '/ERR_DTRC_SAV_DTRC/ {print $7 $11}' $searchFolder/$searchFile5`; do 
                  #Jan 20 08:44:11 s_devlog@(none) dtrc: ERR_DTRC_SAV_DTRC 1,  START: 30030010,  LENGHT: 00021640
                  #awk output: 1,00021640
                  DTRC_NUM=`echo $D|cut -d, -f1`
                  DTRC_LEN=`echo $D|cut -d, -f2|sed 's/^0*//'|tr -d '\r'`
                  DTRC_LEN=`printf "%d" 0x$DTRC_LEN`
                  #now look if dtrc on disk corespondes to this data
                  [ "$POS" = "" ] && BOARD_POS="??" || BOARD_POS=$POS
                  #[ "$BOARD" != "SPA" ] && BOARD_POS="00"
                  DTRC_SUFFIX="$BOARD_POS$DTRC_NUM"
                  for DTRC_FILE in `ls "$searchFolder"/dtrc/dtrc.$DTRC_SUFFIX 2>/dev/null`; do #use ls to expand .??x 
                     [ "`fileLen $DTRC_FILE`" = "$DTRC_LEN" ] && VALID_DTRCS="$VALID_DTRCS"" $DTRC_FILE"
                  done 
                done
              fi
              
              if [ -z "$VALID_DTRCS" ]; then
                 #search for valid dtrc's...
                 if [ ! -z $searchFile6 ]; then
                  for D in `awk '/ERR_DTRC_SAV_DTRC/ {print $7 $11}' $searchFolder/$searchFile6`; do 
                    #Jan 20 08:44:11 s_devlog@(none) dtrc: ERR_DTRC_SAV_DTRC 1,  START: 30030010,  LENGHT: 00021640
                    #awk output: 1,00021640
                    DTRC_NUM=`echo $D|cut -d, -f1`
                    DTRC_LEN=`echo $D|cut -d, -f2|sed 's/^0*//'|tr -d '\r'`
                    DTRC_LEN=`printf "%d" 0x$DTRC_LEN`
                    #now look if dtrc on disk corespondes to this data
                    [ "$POS" = "" ] && BOARD_POS="??" || BOARD_POS=$POS
                    #[ "$BOARD" != "SPA" ] && BOARD_POS="00"
                    DTRC_SUFFIX="$BOARD_POS$DTRC_NUM"
                    for DTRC_FILE in `ls "$searchFolder"/dtrc/dtrc.$DTRC_SUFFIX 2>/dev/null`; do #use ls to expand .??x 
                       [ "`fileLen $DTRC_FILE`" = "$DTRC_LEN" ] && VALID_DTRCS="$VALID_DTRCS"" $DTRC_FILE"
                    done 
                  done
                fi
              fi            
            fi          
          fi        
        fi      
      fi
      
      if [ ! -z "$VALID_DTRCS" ]; then
        #convert ascii to hex
        xxd $VALID_DTRCS > $searchFolder/dtrc/dtrc.hex 

        #change tail to head
        tac $searchFolder/dtrc/dtrc.hex > $searchFolder/dtrc/dtrc1.hex 

        COUNT=0
         
        while [ 1 ]
        do
          TC=""
          CORE=""

          TC=`grep "tc" $searchFolder/dtrc/dtrc1.hex 2>/dev/null`
          
          SEARCHSTRING=""
          if [ ! -z "$TC" ]; then
            SEARCHSTRING="tc"  
          else 
            TC=`grep "ct" $searchFolder/dtrc/dtrc1.hex 2>/dev/null`
            
            if [ ! -z "$TC" ]; then
              SEARCHSTRING="ct"
            fi
          fi
           
          if [ -z "$SEARCHSTRING" ]; then
            break
          fi          
          
          #get first tc
          if [ "$SEARCHSTRING" == "tc" ]; then
            grep -i -A 3 "tc" $searchFolder/dtrc/dtrc1.hex 2>/dev/null | head -4 > $searchFolder/dtrc/dtrc2.hex
          else
            grep -i -A 3 "ct" $searchFolder/dtrc/dtrc1.hex 2>/dev/null | head -4 > $searchFolder/dtrc/dtrc2.hex
          fi 

          #convert hex to ascii
          xxd -r $searchFolder/dtrc/dtrc2.hex > $searchFolder/dtrc/dtrc3.hex
          
          #remove tc/ct
          if [ "$SEARCHSTRING" == "tc" ]; then
            strings $searchFolder/dtrc/dtrc3.hex | grep tc | tail -n1 | sed 's/.*tc *//' -i $searchFolder/dtrc/dtrc3.hex
          else
            strings $searchFolder/dtrc/dtrc3.hex | grep ct | tail -n1 | sed 's/.*ct *//' -i $searchFolder/dtrc/dtrc3.hex
          fi 
          
          #get process
          PROCESCORE=`strings $searchFolder/dtrc/dtrc3.hex`

          #change tc/ct to **
          if [ "$SEARCHSTRING" == "tc" ]; then
            sed '0,/tc/s//**/' -i $searchFolder/dtrc/dtrc1.hex
          else
            sed '0,/ct/s//**/' -i $searchFolder/dtrc/dtrc1.hex
          fi           
          
          COUNT=$(($COUNT + 1))
          
          if [ $COUNT == 100 ]; then
            break
          fi
          
          #get line with CPU core
          if [ "$SEARCHSTRING" == "tc" ]; then
             sed -n '/tc/ {n;p}' $searchFolder/dtrc/dtrc2.hex > $searchFolder/dtrc/dtrc4.hex 
          else
             sed -n '/ct/ {n;p}' $searchFolder/dtrc/dtrc2.hex > $searchFolder/dtrc/dtrc4.hex 
          fi   

          #get CPU core number
          if [ "$SEARCHSTRING" == "tc" ]; then
             CORE=`awk -F  "" '{print $39}' $searchFolder/dtrc/dtrc4.hex` 
          else
             CORE=`awk -F  "" '{print $40}' $searchFolder/dtrc/dtrc4.hex` 
          fi
         
         if [ "$CORE" != "0" ]; then
            local res=$(checkCPUCore "$CORE")
            
            if [ "$res" == "false" ]; then
              if [ ! -z "$CORE" ]; then
                if [ -z "$CORE1" ]; then
                  CORE1=$CORE  
                  if [ ! -z "$PROCESCORE" ]; then
                    PROCESCORE1=$PROCESCORE
                  fi
                else
                  if [ -z "$CORE2" ]; then
                    CORE2=$CORE  
                    if [ ! -z "$PROCESCORE" ]; then
                      PROCESCORE2=$PROCESCORE
                    fi
                  else
                    if [ -z "$CORE3" ]; then
                      CORE3=$CORE  
                      if [ ! -z "$PROCESCORE" ]; then
                        PROCESCORE3=$PROCESCORE
                      fi   
                    else
                      if [ -z "$CORE4" ]; then
                        CORE4=$CORE  
                        if [ ! -z "$PROCESCORE" ]; then
                          PROCESCORE4=$PROCESCORE
                        fi    
                      fi  
                    fi
                  fi  
                fi            
              fi
            fi
          fi
          
        done
 
      fi
      
      if [ -f $searchFolder/dtrc/dtrc.hex ]; then
        rm $searchFolder/dtrc/dtrc.hex
      fi
      if [ -f $searchFolder/dtrc/dtrc1.hex ]; then
        rm $searchFolder/dtrc/dtrc1.hex
      fi
      if [ -f $searchFolder/dtrc/dtrc2.hex ]; then
        rm $searchFolder/dtrc/dtrc2.hex
      fi      
      if [ -f $searchFolder/dtrc/dtrc3.hex ]; then
        rm $searchFolder/dtrc/dtrc3.hex
      fi         
       if [ -f $searchFolder/dtrc/dtrc4.hex ]; then
        rm $searchFolder/dtrc/dtrc4.hex
      fi    
   fi
}

checkDdmp()
{   
  if [[ $checkDdmp == 1 ]]; then   
     #and ddmp's
     for DD in `awk '/dtrc: DDMP OK/ {print $10}' $searchFolder/$searchFile1`; do
        #Jan 20 08:44:11 s_devlog@(none) dtrc: DDMP OK - LENGHT: 0xfe1
        DDMP_LEN=`printf "%d" $DD`
        [ $DDMP_LEN -lt 100 ] && continue  #on SPA there's a lot of short ddmp's  
        for DDMP_FILE in "$searchFolder"/dtrc/ddmp*; do 
           #add ddmp content to end of messages_reset.pre if lengths matches
           [ "`fileLen $DDMP_FILE`" = "$DDMP_LEN" ] && cat $DDMP_FILE >> $searchFolder/dtrc/DDMP.file
        done
     done
     
     if [ -f "$searchFolder/dtrc/DDMP.file" ]; then
       for DD in `awk '/dtrc: DDMP OK/ {print $10}' $searchFolder/$searchFile2`; do
          #Jan 20 08:44:11 s_devlog@(none) dtrc: DDMP OK - LENGHT: 0xfe1
          DDMP_LEN=`printf "%d" $DD`
          [ $DDMP_LEN -lt 100 ] && continue  #on SPA there's a lot of short ddmp's  
          for DDMP_FILE in "$searchFolder"/dtrc/ddmp*; do 
             #add ddmp content to end of messages_reset.pre if lengths matches
             [ "`fileLen $DDMP_FILE`" = "$DDMP_LEN" ] && cat $DDMP_FILE >> $searchFolder/dtrc/DDMP.file
          done
       done
     fi

     if [ -f "$searchFolder/dtrc/DDMP.file" ]; then
       for DD in `awk '/dtrc: DDMP OK/ {print $10}' $searchFolder/$searchFile3`; do
          #Jan 20 08:44:11 s_devlog@(none) dtrc: DDMP OK - LENGHT: 0xfe1
          DDMP_LEN=`printf "%d" $DD`
          [ $DDMP_LEN -lt 100 ] && continue  #on SPA there's a lot of short ddmp's  
          for DDMP_FILE in "$searchFolder"/dtrc/ddmp*; do 
             #add ddmp content to end of messages_reset.pre if lengths matches
             [ "`fileLen $DDMP_FILE`" = "$DDMP_LEN" ] && cat $DDMP_FILE >> $searchFolder/dtrc/DDMP.file
          done
       done
     fi

     if [ -f "$searchFolder/dtrc/DDMP.file" ]; then
       for DD in `awk '/dtrc: DDMP OK/ {print $10}' $searchFolder/$searchFile4`; do
          #Jan 20 08:44:11 s_devlog@(none) dtrc: DDMP OK - LENGHT: 0xfe1
          DDMP_LEN=`printf "%d" $DD`
          [ $DDMP_LEN -lt 100 ] && continue  #on SPA there's a lot of short ddmp's  
          for DDMP_FILE in "$searchFolder"/dtrc/ddmp*; do 
             #add ddmp content to end of messages_reset.pre if lengths matches
             [ "`fileLen $DDMP_FILE`" = "$DDMP_LEN" ] && cat $DDMP_FILE >> $searchFolder/dtrc/DDMP.file
          done
       done
     fi

     if [ -f "$searchFolder/dtrc/DDMP.file" ]; then
       for DD in `awk '/dtrc: DDMP OK/ {print $10}' $searchFolder/$searchFile5`; do
          #Jan 20 08:44:11 s_devlog@(none) dtrc: DDMP OK - LENGHT: 0xfe1
          DDMP_LEN=`printf "%d" $DD`
          [ $DDMP_LEN -lt 100 ] && continue  #on SPA there's a lot of short ddmp's  
          for DDMP_FILE in "$searchFolder"/dtrc/ddmp*; do 
             #add ddmp content to end of messages_reset.pre if lengths matches
             [ "`fileLen $DDMP_FILE`" = "$DDMP_LEN" ] && cat $DDMP_FILE >> $searchFolder/dtrc/DDMP.file
          done
       done
     fi

     if [ -f "$searchFolder/dtrc/DDMP.file" ]; then
       for DD in `awk '/dtrc: DDMP OK/ {print $10}' $searchFolder/$searchFile6`; do
          #Jan 20 08:44:11 s_devlog@(none) dtrc: DDMP OK - LENGHT: 0xfe1
          DDMP_LEN=`printf "%d" $DD`
          [ $DDMP_LEN -lt 100 ] && continue  #on SPA there's a lot of short ddmp's  
          for DDMP_FILE in "$searchFolder"/dtrc/ddmp*; do 
             #add ddmp content to end of messages_reset.pre if lengths matches
             [ "`fileLen $DDMP_FILE`" = "$DDMP_LEN" ] && cat $DDMP_FILE >> $searchFolder/dtrc/DDMP.file
          done
       done  
      fi   

      
    rm $searchFolder/dtrc/DDMP.file
   fi
}

# main script

count=$(xmllint --xpath "count(//reason)" $XML)

if [[ $count != 0 ]]; then
  RESETCOUNT=0
  for ((i = 1; i <= $count; i++)); do     
    boardString1=$(xmllint --xpath "string(//boardString1)" $XML)
    boardString2=$(xmllint --xpath "string(//boardString2)" $XML)
    boardString3=$(xmllint --xpath "string(//boardString3)" $XML)
    
    board1=$(xmllint --xpath "string(//board1)" $XML)
    board2=$(xmllint --xpath "string(//board2)" $XML)
    board3=$(xmllint --xpath "string(//board3)" $XML)
    board4=$(xmllint --xpath "string(//board4)" $XML)
    board5=$(xmllint --xpath "string(//board5)" $XML)
    board6=$(xmllint --xpath "string(//board6)" $XML)
    board7=$(xmllint --xpath "string(//board7)" $XML)
    board8=$(xmllint --xpath "string(//board8)" $XML)
    board9=$(xmllint --xpath "string(//board9)" $XML)
    board10=$(xmllint --xpath "string(//board10)" $XML)
    board11=$(xmllint --xpath "string(//board11)" $XML)
    board12=$(xmllint --xpath "string(//board12)" $XML)
    
    packageString1=$(xmllint --xpath "string(//packageString1)" $XML)
    packageString2=$(xmllint --xpath "string(//packageString2)" $XML)
    packageString3=$(xmllint --xpath "string(//packageString3)" $XML)
  
    boardStartString1=$(xmllint --xpath "string(//boardStartString1)" $XML)
    boardStartString2=$(xmllint --xpath "string(//boardStartString2)" $XML)
    boardStartString3=$(xmllint --xpath "string(//boardStartString3)" $XML)
  
    allReset=$(xmllint --xpath "string(//allReset)" $XML)
  
    if [ -z "$1" ]; then
      searchFolder=$(xmllint --xpath "string(//reason[$i]/searchFolder)" $XML)
    else
      searchFolder="$1"
    fi
    
    searchFile1=$(xmllint --xpath "string(//reason[$i]/searchFile1)" $XML)
    searchFile2=$(xmllint --xpath "string(//reason[$i]/searchFile2)" $XML)
    searchFile3=$(xmllint --xpath "string(//reason[$i]/searchFile3)" $XML)
    searchFile4=$(xmllint --xpath "string(//reason[$i]/searchFile4)" $XML)
    searchFile5=$(xmllint --xpath "string(//reason[$i]/searchFile5)" $XML)
    searchFile6=$(xmllint --xpath "string(//reason[$i]/searchFile6)" $XML)

    searchString1=$(xmllint --xpath "string(//reason[$i]/searchString1)" $XML)
    searchString2=$(xmllint --xpath "string(//reason[$i]/searchString2)" $XML)
    searchString3=$(xmllint --xpath "string(//reason[$i]/searchString3)" $XML)

    string1MaxLineNumbers=$(xmllint --xpath "string(//reason[$i]/string1MaxLineNumbers)" $XML)
    string2MaxLineNumbers=$(xmllint --xpath "string(//reason[$i]/string2MaxLineNumbers)" $XML)
    string3MaxLineNumbers=$(xmllint --xpath "string(//reason[$i]/string3MaxLineNumbers)" $XML)

    allSearchString=$(xmllint --xpath "string(//reason[$i]/allSearchString)" $XML)
    
    command1=$(xmllint --xpath "string(//reason[$i]/command1)" $XML)
    command2=$(xmllint --xpath "string(//reason[$i]/command2)" $XML)
    command3=$(xmllint --xpath "string(//reason[$i]/command3)" $XML)
    command4=$(xmllint --xpath "string(//reason[$i]/command4)" $XML)
    command5=$(xmllint --xpath "string(//reason[$i]/command5)" $XML)
    command6=$(xmllint --xpath "string(//reason[$i]/command6)" $XML)
    command7=$(xmllint --xpath "string(//reason[$i]/command7)" $XML)
    command8=$(xmllint --xpath "string(//reason[$i]/command8)" $XML)
    command9=$(xmllint --xpath "string(//reason[$i]/command9)" $XML)
    command10=$(xmllint --xpath "string(//reason[$i]/command10)" $XML)
    
    resetString=$(xmllint --xpath "string(//reason[$i]/resetString)" $XML)

    coreDump=$(xmllint --xpath "string(//reason[$i]/coreDump)" $XML)
    coreDumpSearchString1=$(xmllint --xpath "string(//reason[$i]/coreDumpSearchString1)" $XML)
    coreDumpString1MaxLineNumbers=$(xmllint --xpath "string(//reason[$i]/coreDumpString1MaxLineNumbers)" $XML)

    checkDtrc=$(xmllint --xpath "string(//reason[$i]/checkDtrc)" $XML)
    checkDdmp=$(xmllint --xpath "string(//reason[$i]/checkDdmp)" $XML)
    
    RESET_DATE="unknown" 
    STEER_VER="unknown"
    BOARD_TYPE="unknown"
    RESET_REASON="No information available on reset!"
    CORE_DUMP=""

    getResetDate
    getResetPackage
    getResetBoard
    getResetReason
    getCoreDump
    
    checkDtrc
    #checkDdmp

    if [[ $allReset == 0 ]]; then
      if [[ "$RESET_REASON" != "No information available on reset!" ]]; then
        printResult
        RESETCOUNT=$(( RESETCOUNT + 1 ))
        break
      fi
    else
      if [[ "$RESET_REASON" != "No information available on reset!" ]]; then
        printResult
        RESETCOUNT=$(( RESETCOUNT + 1 ))
      fi
    fi

    if [[ $DEBUG == 1 ]]; then
      echo $boardString1
      echo $boardString2
      echo $boardString3
      echo $board1
      echo $board2
      echo $board3
      echo $board4
      echo $board5
      echo $board6
      echo $board7
      echo $board8
      echo $board9
      echo $board10
      echo $board11
      echo $board12
      echo $packageString1
      echo $packageString2
      echo $packageString3
      echo $boardStartString1
      echo $boardStartString2
      echo $boardStartString3
      echo $searchFolder
      echo $searchFile1
      echo $searchFile2
      echo $searchFile3
      echo $searchFile4
      echo $searchFile5
      echo $searchFile6
      echo $searchString1
      echo $searchString2
      echo $searchString3
      echo $string1MaxLineNumbers
      echo $string2MaxLineNumbers
      echo $string3MaxLineNumbers
      echo $allSearchString
      echo $command1
      echo $command2
      echo $command3
      echo $command4
      echo $command5
      echo $command6
      echo $command7
      echo $command8
      echo $command9
      echo $command10
      echo $resetString
      echo $coreDump
      echo $checkDtrc
      echo $checkDdmp
      echo $coreDumpSearchString1
      echo $coreDumpString1MaxLineNumbers
      echo $allReset
    fi
       
    done
    
  if [[ $RESETCOUNT == 0 ]]; then
    printResult
  fi
fi

